
%    Copyright (C) 2015  Davide Modolo
%
%    You can redistribute and/or modify this software for non-commercial use
%    under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
%    For commercial use, contact the author for licensing options.
%
%    Contact: d.modolo@sms.ed.ac.uk

% Scores of 4 Exemplar-SVMs (E) on 16 windows (W), 6 positive and 10 negative
% The matrix is [W x E]
eesvms_scores = [0 1 2 8; ...           % p1
                3 4 0 5; ...            % p2
                5 1.5 0.5 5.5; ...      % p3
                -2 -1 2 -2; ...         % p4
                1 2 4 3; ...            % p5
                3.5 4 7 1; ...          % p6
                4 -3 6 -1; ...          % n1
                2 5 1 2; ...            % n2
                0.5 -2 3 1.5; ...       % n3
                -0.5 -5 -0.5 0; ...     % n4
                -1 3 5 -3; ...          % n5
                -3 -2 -1 6; ...         % n6
                -4 0 -6 2; ...          % n7
                -5 -3 -10 -6; ...       % n8 
                -6 -10 -1.5 10; ...     % n9 
                -7 -2 -5 -8];           % n10

% Lables of the 16 windows (have to be logical)            
labels = logical([ones(6, 1); zeros(10, 1)]);            

% Version of the joint calibration you want to use
% It can either be 'GLOBAL' (paper, sec. 4.3) or 'APPROXIMATE' (sec. 4.4)
% The latter version will stop the search after 'time' seconds. 
% In this example, after 3600 seconds (one hour)
version = 'APPROXIMATE';
time = 3600; 

% Main function
thresholds = joint_calibration(eesvms_scores, labels, version, time);

% Expected output ->  thresholds = [4.5, -1.5, 6.5, Inf]